---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.14.0
  name: sriovnetworknodepolicies.sriovnetwork.openshift.io
spec:
  group: sriovnetwork.openshift.io
  names:
    kind: SriovNetworkNodePolicy
    listKind: SriovNetworkNodePolicyList
    plural: sriovnetworknodepolicies
    singular: sriovnetworknodepolicy
  scope: Namespaced
  versions:
    - name: v1
      schema:
        openAPIV3Schema:
          description: SriovNetworkNodePolicy is the Schema for the sriovnetworknodepolicies
            API
          properties:
            apiVersion:
              description: |-
                APIVersion defines the versioned schema of this representation of an object.
                Servers should convert recognized schemas to the latest internal value, and
                may reject unrecognized values.
                More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
              type: string
            kind:
              description: |-
                Kind is a string value representing the REST resource this object represents.
                Servers may infer this from the endpoint the client submits requests to.
                Cannot be updated.
                In CamelCase.
                More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
              type: string
            metadata:
              type: object
            spec:
              description: SriovNetworkNodePolicySpec defines the desired state of SriovNetworkNodePolicy
              properties:
                bridge:
                  description: |-
                    contains bridge configuration for matching PFs,
                    valid only for eSwitchMode==switchdev
                  properties:
                    ovs:
                      description: contains configuration for the OVS bridge,
                      properties:
                        bridge:
                          description: contains bridge level settings
                          properties:
                            datapathType:
                              description: configure datapath_type field in the Bridge
                                table in OVSDB
                              type: string
                            externalIDs:
                              additionalProperties:
                                type: string
                              description: IDs to inject to external_ids field in the
                                Bridge table in OVSDB
                              type: object
                            otherConfig:
                              additionalProperties:
                                type: string
                              description: additional options to inject to other_config
                                field in the bridge table in OVSDB
                              type: object
                          type: object
                        uplink:
                          description: contains settings for uplink (PF)
                          properties:
                            interface:
                              description: contains settings for PF interface in the
                                OVS bridge
                              properties:
                                externalIDs:
                                  additionalProperties:
                                    type: string
                                  description: external_ids field in the Interface table
                                    in OVSDB
                                  type: object
                                mtuRequest:
                                  description: mtu_request field in the Interface table
                                    in OVSDB
                                  type: integer
                                options:
                                  additionalProperties:
                                    type: string
                                  description: options field in the Interface table
                                    in OVSDB
                                  type: object
                                otherConfig:
                                  additionalProperties:
                                    type: string
                                  description: other_config field in the Interface table
                                    in OVSDB
                                  type: object
                                type:
                                  description: type field in the Interface table in
                                    OVSDB
                                  type: string
                              type: object
                          type: object
                      type: object
                  type: object
                deviceType:
                  default: netdevice
                  description: The driver type for configured VFs. Allowed value "netdevice",
                    "vfio-pci". Defaults to netdevice.
                  enum:
                    - netdevice
                    - vfio-pci
                  type: string
                eSwitchMode:
                  description: NIC Device Mode. Allowed value "legacy","switchdev".
                  enum:
                    - legacy
                    - switchdev
                  type: string
                excludeTopology:
                  description: Exclude device's NUMA node when advertising this resource
                    by SRIOV network device plugin. Default to false.
                  type: boolean
                externallyManaged:
                  description: don't create the virtual function only allocated them
                    to the device plugin. Defaults to false.
                  type: boolean
                isRdma:
                  description: RDMA mode. Defaults to false.
                  type: boolean
                linkType:
                  description: NIC Link Type. Allowed value "eth", "ETH", "ib", and
                    "IB".
                  enum:
                    - eth
                    - ETH
                    - ib
                    - IB
                  type: string
                mtu:
                  description: MTU of VF
                  minimum: 1
                  type: integer
                needVhostNet:
                  description: mount vhost-net device. Defaults to false.
                  type: boolean
                nicSelector:
                  description: NicSelector selects the NICs to be configured
                  properties:
                    deviceID:
                      description: The device hex code of SR-IoV device. Allowed value
                        "0d58", "1572", "158b", "1013", "1015", "1017", "101b".
                      type: string
                    netFilter:
                      description: Infrastructure Networking selection filter. Allowed
                        value "openstack/NetworkID:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
                      type: string
                    pfNames:
                      description: Name of SR-IoV PF.
                      items:
                        type: string
                      type: array
                    rootDevices:
                      description: PCI address of SR-IoV PF.
                      items:
                        type: string
                      type: array
                    vendor:
                      description: The vendor hex code of SR-IoV device. Allowed value
                        "8086", "15b3".
                      type: string
                  type: object
                nodeSelector:
                  additionalProperties:
                    type: string
                  description: NodeSelector selects the nodes to be configured
                  type: object
                numVfs:
                  description: Number of VFs for each PF
                  minimum: 0
                  type: integer
                priority:
                  description: Priority of the policy, higher priority policies can
                    override lower ones.
                  maximum: 99
                  minimum: 0
                  type: integer
                resourceName:
                  description: SRIOV Network device plugin endpoint resource name
                  type: string
                vdpaType:
                  description: VDPA device type. Allowed value "virtio", "vhost"
                  enum:
                    - virtio
                    - vhost
                  type: string
              required:
                - nicSelector
                - nodeSelector
                - numVfs
                - resourceName
              type: object
            status:
              description: SriovNetworkNodePolicyStatus defines the observed state of
                SriovNetworkNodePolicy
              type: object
          type: object
      served: true
      storage: true
      subresources:
        status: {}
